

/*
   Todo list
   Add the acutal buffer
   Add  buffer clear
   Add buffer add
   Add buffer next
   Add buffer read

*/

#define buffer_size 256 //the size of the buffer. 

uint8_t buffer_array[buffer_size][22][2];
uint32_t buffer_aux[buffer_size];
uint32_t buffer_read_pos[2];
uint32_t buffer_write_pos;



//starts the buffer and creates all values
void BufferStart() {
  BufferClear();
}


//completely clears the buffer and resets all values
void BufferClear() {
  for (uint32_t c = 0; c < buffer_size; c++) { //erase all data in the arrays
    for (uint8_t a = 0; a < 22; a++) {
      buffer_array[c][a][0] = 0;
      buffer_array[c][a][1] = 0;
    }
  }
  buffer_read_pos[0] = 0; //set read position to 0
  buffer_read_pos[1] = 0; //set read position to 0
  buffer_write_pos = 1; //set wrrite position to 1
}




//returns the amount of positions that can be written
int32_t BufferWriteLeft() {
  int32_t temp_return_val1, temp_return_val2;
  //check read pos 1
  if (buffer_write_pos < buffer_read_pos[0]) { //if read is higher than write
    temp_return_val1 = buffer_read_pos[0];
    temp_return_val1 -= buffer_write_pos;
  }
  else {  //write has wrapped back to 0
    temp_return_val1 = buffer_size;
    temp_return_val1 -= buffer_write_pos;
    temp_return_val1 += buffer_read_pos[0];
  }
  //check read pos 2
  if (buffer_write_pos < buffer_read_pos[1]) { //if read is higher than write
    temp_return_val2 = buffer_read_pos[1];
    temp_return_val2 -= buffer_write_pos;
  }
  else {  //write has wrapped back to 0
    temp_return_val2 = buffer_size;
    temp_return_val2 -= buffer_write_pos;
    temp_return_val2 += buffer_read_pos[1];
  }

  temp_return_val1 --; //subtract 1 extra to keep the values from being the same
  temp_return_val2 --;

  //return smallest value
  if (temp_return_val1 < temp_return_val2) return temp_return_val1;
  else return temp_return_val2;
}

//returns the amount of positions that can be read
int32_t BufferReadLeft(uint8_t temp_input) {
  int32_t temp_return_val;
  if (buffer_read_pos[temp_input] < buffer_write_pos) { //if write is higher than read
    temp_return_val = buffer_write_pos;
    temp_return_val -= buffer_read_pos[temp_input];
  }
  else {  //write has wrapped back to 0
    temp_return_val = buffer_size;
    temp_return_val -= buffer_read_pos[temp_input];
    temp_return_val += buffer_write_pos;
  }

  temp_return_val --; //subtract 1 extra to keep the values from being the same
  return temp_return_val;
  //if read = write + 1, the amount of read left is 0
  //if write = read +1, the amount of write left is 0
  //read and write will never be equal
  //At buffer_size the value wraps back to 0

  //read left
  //read 5, write 10 is 4 left
  //read 10, write 5, size 20 is 14 left

  //write left
  //read 5, write 10, size 20 is 14 left
  //read 10, write 5 is 4 left
}




//adds a printhead  position to the buffer and returns the amount of space remaining
int32_t BufferAddValue(uint16_t temp_array[][2], uint32_t temp_value) {
  int32_t temp_space = BufferWriteLeft(); //check if there is space left
  if (temp_space == 0) return 0; //break function, return 0

  //write the data in the arguments to the buffer
  for (uint8_t a = 0; a < 22; a++) {
    buffer_array[buffer_write_pos][a][0] = temp_array[a][0];
    buffer_array[buffer_write_pos][a][1] = temp_array[a][1];
  }
  buffer_aux[buffer_write_pos] = temp_value;

  buffer_write_pos ++; //add one to write value
}


//advances the buffer by one. 0/1 determine which halve of the buffer is advanced
int32_t BufferNext(uint8_t temp_value) {
  
}
