/*

  This is the Firmware for the HP45 Standalone V2.01 controller.

   The Standalone controller uses a teensy 3.2 (Overclocked to 96MHz) and the TLC, 595 and 4017 based printhead control circuit to print.

   This firmware is written in the hope that it will be useful, but with no garuantee that it will work or won't damage anything. Use at your own discretion.

   Latest version (V2.01-01) written: 29-09-2017 (dd-mm-yyyy) by Yvo de Haas
*/

/*
   Todo list
*/

uint32_t tempmillis = millis() + 500;
uint8_t temp_state = 0;


void setup() {
  //start the printhead
  PrintheadStart();
  PrintingStart();

  //delay(1000); PrintheadGenerateNewRawTables(); //used for the creation of new tables

}

void loop() {
  SerialUpdate();

  /*if (millis() > tempmillis){
    if (temp_state){
      PrintheadEnable();
      temp_state = 0;
    }
    else {
      PrintheadDisable();
      temp_state = 1;
    }
    tempmillis = millis() + 500;
    }//*/

  //enable test
  /*PrintheadEnable();
    delay(1000);
    PrintheadDisable();
    delay(1000);//*/

  //shift and latch test
  /*PrintheadAddressReset();
    for (uint8_t a = 0; a < 24; a++){
    PrintheadAddressNext();
    delay(500);
    }//*/

  /*PrintheadPrimitiveClockLow();
    PrintheadPrimitiveClearLow();
    PrintheadShiftSet2B(0,255);
    PrintheadPrimitiveClearHigh();
    PrintheadPrimitiveClockHigh();

    delay(5000);

    PrintheadPrimitiveClockLow();
    PrintheadPrimitiveClearLow();
    PrintheadShiftSet2B(255, 0);
    PrintheadPrimitiveClearHigh();
    PrintheadPrimitiveClockHigh();

    delay(5000); //*/

  //fire all test
  /*PrintheadEnable();
    delay(1);
    PrintheadAddressReset();
    for (uint8_t a = 0; a < 22; a++){
    PrintheadAddressNext();
    PrintheadInkjetPulse2B(255,255);
    }
    PrintheadDisable();
    delay(100);//*/

  //row test
  /*PrintheadTempTriggerRow();
    delay(5000);//*/

  //test test
  /*int8_t temp_nozzle_state[300];
    Serial.println("");
    Serial.println("start test");
    PrintheadTestNozzles(temp_nozzle_state);
    for (uint16_t n = 0; n < 300; n ++){
    int8_t temp_val = temp_nozzle_state[n];
    Serial.print(temp_val);
    Serial.print(", ");
    if (n % 10 == 9){
      Serial.println("");
    }
    }
    delay(10000);//*/

  //burst test
  /*PrintheadEnable();
    //high
    uint16_t print_array[22];
    uint8_t temp_state = 1;
    for (uint8_t a = 0; a < 22; a++) {
    if (temp_state == 0) {
      print_array[a] = 65535; //65535
      temp_state = 1;
    }
    else {
      print_array[a] = 0;
      temp_state = 0;
    }
    }
    for (uint8_t a = 0; a < 100; a++) {
    PrintheadInkjetBurstW(print_array);
    }
    delay(1000);

    PrintheadDisable();
    delay(1000);//*/


  //diagonal row test
  /*PrintheadEnable();

    int16_t temp_row_start; //row end is r
    uint16_t print_array[22]; //printing array
    int8_t temp_row_width = 50;

    //reset printing array
    for (uint8_t c = 0; c < 22; c++) {
    print_array[c] = 0;
    }

    for (int16_t r = 1; r < 400; r += 2) {
    temp_row_start = r - temp_row_width; //calculate starting point

    for (int16_t n = 1; n < 300; n += 2) { //loop through all nozzles to check their state
      //fill the array with the data if it is within the row to print
      if (n >= temp_row_start && n <= r){
        bitWrite(print_array[PrintheadGetAddress(n)], PrintheadGetPrimitive(n), 1);
      }
      else {
        bitWrite(print_array[PrintheadGetAddress(n)], PrintheadGetPrimitive(n), 0);
      }
    }

    PrintheadInkjetBurstW(print_array); //print the array

    delay(5); //delay to slow the function down
    }

    PrintheadDisable();
    delay(4000); //*/

  /*PrintheadSetEnable(1);
    PrintheadGetTemperature(1);
    Serial.print("C= "); Serial.print(PrintheadGetTemperature(1));
    Serial.print(", F= "); Serial.println(PrintheadGetTemperature(2));
    PrintheadSetEnable(0);
    delay(1000); //*/

}

